; C near-callable as:
;    void FillRectangleX(int StartX, int StartY, int EndX, int EndY,
;       unsigned int PageBase, int Color);

;SC_INDEX equ    03c4h   ;Sequence Controller Index
;MAP_MASK equ    02h     ;index in SC of Map Mask register
;SCREEN_SEG equ  0a000h  ;segment of display memory in mode X
;SCREEN_WIDTH equ 80     ;width of screen in bytes from one scan line
                        ; to the next
;parms   struc
;        dw      2 dup (?) ;pushed BP and return address
;StartX  dw      ?       ;X coordinate of upper left corner of rect
;StartY  dw      ?       ;Y coordinate of upper left corner of rect
;EndX    dw      ?       ;X coordinate of lower right corner of rect
			; (the row at EndX is not filled)
;EndY    dw      ?       ;Y coordinate of lower right corner of rect
			; (the column at EndY is not filled)
;PageBase dw     ?       ;base offset in display memory of page in
			; which to fill rectangle
;Color   dw      ?       ;color in which to draw pixel
;parms   ends

	.model  small
	.data
; Plane masks for clipping left and right edges of rectangle.
LeftClipPlaneMask       db      00fh,00eh,00ch,008h
RightClipPlaneMask      db      00fh,001h,003h,007h

	.code
	public  _FillRectangleX

_FillRectangleX proc    near
_FillRectangleX endp
	end


; C near-callable as:
;void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
;// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
;// Procedure Scale (x,y,w,h,origw,origh,source,dest:word); assembler;
;//  { This scales the picture to the size of w and h, and places the result
;//    at x , y. Origw and origh are the origional width and height of the
;//    bitmap. The bitmap must start at the beginning of a segment, with
;//    source being the segment value. The image is placed in screen at dest}
;void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
;{int jx,jy,depth,temp;

 jx      dw      ?
 jy      dw      ?
 depth   dw      ?
 temp    dw      ?

	.model  small
	.data

	.code
	public  _scale

_scale proc     near

  push  ds
  mov   ax,source
  mov   ds,ax
  mov   ax,dest
  mov   es,ax
  mov   depth,0
  dec   h
  xor   dx,dx
  mov   ax,origw
  shl   ax,6
  mov   bx,w
  div   bx
  shl   ax,2
  mov   jx,ax    ; { jx:=origw*256/w }
  xor   dx,dx
  mov   ax,origh
  shl   ax,6
  mov   bx,h
  div   bx
  shl   ax,2
  mov   jy,ax    ; { jy:=origh*256/h }
  xor   cx,cx
ALoop2:          ; { vertical loop }
  push  cx
  mov   ax,depth
  add   ax,jy
  mov   depth,ax
  xor   dx,dx
  mov   ax,depth
  shr   ax,8
  mov   bx,origw
  mul   bx
  mov   temp,ax  ; { temp:=depth shr 8*origw;}
  mov   di,y
  add   di,cx
  mov   bx,di
  shl   di,8
  shl   bx,6
  add   di,bx
  add   di,x     ; { es:di = dest ... di=(loop1+y)*320+x }
  mov   cx,w
  xor   bx,bx
  mov   dx,jx
  mov   ax,temp
ALoop1:         ; { horizontal loop }
  mov   si,bx
  shr   si,8
  add   si,ax    ; { ax = temp = start of line }
  movsb          ; { si=temp+(si shr 8) }
  add   bx,dx
  dec   cx
  jnz   ALoop1   ; { horizontal loop }
  pop   cx
  inc   cx
  cmp   cx,h
  jl    ALoop2   ; { vertical loop }
  pop   ds

 _scale endp
	end

