/* 
  10/30/94
  tut16.c
  from tutprog16.pas
  Adapted from Denthor's tutprog16.pas
  Translated into C, from Denthor's VGA Trainer, by
  Steve Pinault, scp@ohm.att.com
  Compiled with Microsoft Visual C++ 1.5 (Microsoft C 8.0)
  To compile:
  First compile the subroutines in tutsubs.c with the batch file 
  cltutsub.bat
  Then compile any of the tutor programs with the batch file
  cltut.bat
  Example: C:>cltutsub
           C:>cltut tut16.c
           to compile this program.
*/

#include "tcheadr.h"

//extern void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
// {
// int depth, jx, jy, temp;
// };

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure LoadCELPal (FileName : String; Var Palette : Pallette);
//   { This loads in the pallette of the .CEL file into the variable Palette }

void loadcelpal(char* fname, char palette[][3])
{
  FILE* fptr;
  if((fptr=fopen(fname,"rb"))==NULL)
  {
    SetText();
    printf("Error opening file %s\n",fname);
    exit(1);
  }
  fseek(fptr,32,SEEK_SET);
  fread(palette,sizeof(char),768,fptr);
  fclose(fptr);                    
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Init;
void init()
{
  int loop1,loop2;
  char tpal[256][3];
  
  SetUpVirtual();
//  Cls (0,Vaddr2);
//  Cls (0,Vaddr);
//  loadcelpal ("pcteam.map",tpal);
//  loadcelpal ("to.cel",tpal);
  loadcelpal ("from.cel",tpal);
  for(loop1=0;loop1<256;loop1++)
    Pal ((char)loop1,tpal[loop1][0],tpal[loop1][1],tpal[loop1][2]);
//  LoadCEL ("pcteam.map",Virtual);
//  LoadCEL ("to.cel",Virtual);
  LoadCEL ("from.cel",Virtual);
  for(loop1=0;loop1<320;loop1++)
    for(loop2=0;loop2<200;loop2++)
      if(GetPixel(loop1,loop2,Vaddr)==0)
        PutPixel(loop1,loop2,(char)((loop1+loop2)%256),Vaddr);
}        

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Scale (x,y,w,h,origw,origh,source,dest:word); assembler;
//  { This scales the picture to the size of w and h, and places the result
//    at x , y. Origw and origh are the origional width and height of the
//    bitmap. The bitmap must start at the beginning of a segment, with
//    source being the segment value. The image is placed in screen at dest}

void scale(int x,int y,int w,int h,int origw,int origh,int source,int dest)
{
  int jx,jy,depth,temp;
  {
asm  push  ds
asm  mov   ax,source
asm  mov   ds,ax
asm  mov   ax,dest
asm  mov   es,ax
asm  mov   depth,0
asm  dec   h
asm  xor   dx,dx
asm  mov   ax,origw
asm  shl   ax,6
asm  mov   bx,w
asm  div   bx
asm  shl   ax,2
asm  mov   jx,ax  //  ; { jx:=origw*256/w }
asm  xor   dx,dx
asm  mov   ax,origh
asm  shl   ax,6
asm  mov   bx,h
asm  div   bx
asm  shl   ax,2
asm  mov   jy,ax   // ; { jy:=origh*256/h }
asm  xor   cx,cx
ALoop2:        // ; { vertical loop }
asm  push  cx
asm  mov   ax,depth
asm  add   ax,jy
asm  mov   depth,ax
asm  xor   dx,dx
asm  mov   ax,depth
asm  shr   ax,8
asm  mov   bx,origw
asm  mul   bx
asm  mov   temp,ax // ; { temp:=depth shr 8*origw;}
asm  mov   di,y
asm  add   di,cx
asm  mov   bx,di
asm  shl   di,8
asm  shl   bx,6
asm  add   di,bx
asm  add   di,x    // ; { es:di = dest ... di=(loop1+y)*320+x }
asm  mov   cx,w
asm  xor   bx,bx
asm  mov   dx,jx
asm  mov   ax,temp
ALoop1:       //  ; { horizontal loop }
asm  mov   si,bx
asm  shr   si,8
asm  add   si,ax  //  ; { ax = temp = start of line }
asm  movsb         // ; { si=temp+(si shr 8) }
asm  add   bx,dx
asm  dec   cx
asm  jnz   ALoop1  // ; { horizontal loop }
asm  pop   cx
asm  inc   cx
asm  cmp   cx,h
asm  jl    ALoop2 //  ; { vertical loop }
asm  pop   ds
 }
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure Play;
void play()
{
  int x,y,z,loop1;
  z=114;
  while(1)
  {
    for(loop1=0;loop1<100;loop1++)
    {
      z--;
      x=(16<<8)/z; 
      y=(10<<8)/z;
      // { Perspective transforms ... makes the zoom smoother }
//      Cls (0,Vaddr2);
      scale (160-(x >> 1),100-(y >> 1),x,y,320,200,Vaddr,Vaddr2);
      WaitRetrace();
      Flip2 (Vaddr2,VGA);
    }
    //   { Scale towards you }
    for(loop1=0;loop1<100;loop1++)
    {
      z++;
      x=(16<<8)/z; 
      y=(10<<8)/z;
      // { Perspective transforms ... makes the zoom smoother }
//      Cls (0,Vaddr2);
      scale (160-(x >> 1),100-(y >> 1),x,y,320,200,Vaddr,Vaddr2);
      WaitRetrace();    
      Flip2 (Vaddr2,VGA);
    }
    if(_bios_keybrd(_KEYBRD_READY)){getch();break;}
  }
}
 
void main()
{ 
  SetUpVirtual();
  SetMCGA();
  init();
  play();
  SetText();
}          

/*
   ('Hokay! Here is the sixteenth tutorial! This one is on nice fast 2d');
   ('scaling, for any size bitmap. Just hit any key and it will scale a');
   ('picture up and down. Clipping is NOT performed, so the destination');
   ('pic MUST fit in the screen boundaries. In one zoom towards and away');
   ('from you there is 100 frames.');
  ;
   ('You can make many nice effects with scaling, this "bouncing" is just');
   ('one of them ... go on, amaze everyone with your ingenuity ;-) Also,');
   ('why not test your coding mettle, so to speak, by implementing clipping?');
  ;
   ('The routine could greatly be speeded up with 386 extended registers, but');
   ('for the sake of compatability I have kept it to 286 code. Also, this');
   ('routine isn''t fully optimised .. you may be able to get some speedups');
   ('out of it... (probably by moving the finding of DI out of the loop and');
   ('just adding a constant for each line ... hint hint) ;)');
  ;
   ('The pic was drawn by me for Tut11, I am reusing it because I am at varsity..');
   ('without a mouse. :(');
  ;
  ;
   ('Hit any key to continue ... ');
   ('All done. This concludes the sixteenth sample program in the ASPHYXIA');
   ('Training series. You may reach DENTHOR under the names of GRANT');
   ('SMITH/DENTHOR/ASPHYXIA on the ASPHYXIA BBS.I also occasinally');
   ('RSAProg, comp.lang.pascal and comp.sys.ibm.pc.demos. E-mail me at :');
   ('    denthor@beastie.cs.und.ac.za');
   ('The numbers are available in the main text. You may also write to me at:');
   ('             Grant Smith');
   ('             P.O. Box 270');
   ('             Kloof');
   ('             3640');
   ('             Natal');
   ('             South Africa');
   ('I hope to hear from you soon!');
  ; ;
  Write   ('Hit any key to exit ...');
*/
