/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// TUT9D.CPP - VGA Trainer Program 9 (in Turbo C++ 3.0)                    //
// Program Notes : This program demonstrates polygon moving and rotation.  //
//                                                                         //
//                                                                         //
// Author        : Grant Smith (Denthor) - denthor@beastie.cs.und.ac.za    //
// Translator    : Christopher G. Mann   - r3cgm@dax.cc.uakron.edu         //
//                                                                         //
// Last Modified : January 21, 1995                                        //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////


  #include <conio.h>         // clrscr(), getch(), kbhit()
  #include <iostream.h>      // cout()
  #include <math.h>          // sin(), cos()
  #include <stdlib.h>        // exit()
  #include <bios.h>
  #include "gfx2.cpp"        // our graphics library tools


// TYPEDEFS //

  typedef unsigned char byte;
  typedef unsigned int  word;


// CONSTANTS //

  const MAXPOLYS   = 5;
  const maxpolys   = 6;   //andadd
  const POLYPOINTS = 4;
  const POLYCORDS  = 3;


// LETTER DATA //


  // The 3-D coordinates of our object ... stored as {X1,Y1,Z1},
  // {X2,Y2,Z2} ... for the 4 points of a poly.
/*  const int A[MAXPOLYS][POLYPOINTS][POLYCORDS] =
	    { {{-10, 10, 0},{ -2,-10, 0},{ 0,-10, 0},{ -5,10, 0}},   // 1
	      {{ 10, 10, 0},{  2,-10, 0},{ 0,-10, 0},{  5,10, 0}},   // 2
	      {{ -2,-10, 0},{  2,-10, 0},{ 2, -5, 0},{ -2,-5, 0}},   // 3
	      {{ -6,  0, 0},{  6,  0, 0},{ 7,  5, 0},{ -7, 5, 0}},   // 4
	      {{  0,  0, 0},{  0,  0, 0},{ 0,  0, 0},{  0, 0, 0}} }; // 5
//andadd      {{  0,  0, 0},{  0,  0, 0},{ 0,  0, 0},{  0, 0, 0}} }; // 5

*/
  //                             1----1    +    2----2
  //                             |....|    |    |....|
  //                             |....|    |    |....|
  //                             `....`    |    '....'
  //                              |....|   |   |....|
  //                              `.4------+------4.'
  //                               ||......|......||
  //                               ``......|......''
  //                                ||.....|.....||
  //                                ||.....|.....||
  //                      -------+---4+----+----+4---+-------
  //                                 |...| | |...|
  //                                 `...` | '...'
  //                                  |...|||...|
  //                                   |...|...|
  //                                   |.3-+-3.|
  //                                   `.|.|.|.'
  //                                    ||.|.||
  //                                    ||.|.||
  //                                    `|.|.|'
  //                                     3-2-3

//  const int B[MAXPOLYS][POLYPOINTS][POLYCORDS] =   //andadd
  const int B[maxpolys][POLYPOINTS][POLYCORDS] =   //andadd
       { {{-10,-10,10},{-10,10,10},{10,10,10},{10,-10,10}},
	 {{-10,-10,-10},{-10,10,-10},{10,10,-10},{10,-10,-10}},
	 {{-10,-10,-10},{-10,10,-10},{-10,10,10},{-10,-10,10}},
	 {{10,-10,-10},{10,10,-10},{10,10,10},{10,-10,10}},
	 {{10,-10,10},{10,-10,-10},{-10,-10,-10},{-10,-10,10}},
	 {{10,10,10},{10,10,-10},{-10,10,-10},{-10,10,10}} };  //andadd

  const int E[maxpolys][POLYPOINTS][POLYCORDS] =   //andadd
       { {{-12,-12,12},{-12,12,12},{12,12,12},{12,-12,12}},
	 {{-12,-12,-12},{-12,12,-12},{12,12,-12},{12,-12,-12}},
	 {{-12,-12,-12},{-12,12,-12},{-12,12,12},{-12,-12,12}},
	 {{12,-12,-12},{12,12,-12},{12,12,12},{12,-12,12}},
	 {{12,-12,12},{12,-12,-12},{-12,-12,-12},{-12,-12,12}},
	 {{12,12,12},{12,12,-12},{-12,12,-12},{-12,12,12}} };  //andadd

  const int F[maxpolys][POLYPOINTS][POLYCORDS] =   //andadd
       { {{-4,-4,4},{-4,4,4},{4,4,4},{4,-4,4}},
	 {{-4,-4,-4},{-4,4,-4},{4,4,-4},{4,-4,-4}},
	 {{-4,-4,-4},{-4,4,-4},{-4,4,4},{-4,-4,4}},
	 {{4,-4,-4},{4,4,-4},{4,4,4},{4,-4,4}},
	 {{4,-4,4},{4,-4,-4},{-4,-4,-4},{-4,-4,4}},
	 {{4,4,4},{4,4,-4},{-4,4,-4},{-4,4,4}} };  //andadd

int a[maxpolys][4][3] =           //andadd
{
	 {{-10,-10,10},{-10,10,10},{10,10,10},{10,-10,10}},
	 {{-10,-10,-10},{-10,10,-10},{10,10,-10},{10,-10,-10}},
	 {{-10,-10,-10},{-10,10,-10},{-10,10,10},{-10,-10,10}},
         {{10,-10,-10},{10,10,-10},{10,10,10},{10,-10,10}},

	 {{10,-10,10},{10,-10,-10},{-10,-10,-10},{-10,-10,10}},
	 {{10,10,10},{10,10,-10},{-10,10,-10},{-10,10,10}}
};
	// The 3-D coordinates of our object ... stored as (X1,Y1,Z1), }
	// (X2,Y2,Z2) ... for the 4 points of a poly }

  int c[maxpolys][4][3] =
{
	 {{-10,-10,3},{-10,10,3},{10,10,3},{10,-10,3}},
	 {{-10,-10,-3},{-10,10,-3},{10,10,-3},{10,-10,-3}},
	 {{-10,-10,-3},{-10,10,-3},{-10,10,3},{-10,-10,3}},
	 {{10,-10,-3},{10,10,-3},{10,10,3},{10,-10,3}},
	 {{10,-10,3},{10,-10,-3},{-10,-10,-3},{-10,-10,3}},
	 {{10,10,3},{10,10,-3},{-10,10,-3},{-10,10,3}}
};

  int d[maxpolys][4][3] =
{
	 {{-5,-5,5},{-5,5,5},{5,5,5},{5,-5,5}},
	 {{-5,-5,-5},{-5,5,-5},{5,5,-5},{5,-5,-5}},
	 {{-5,-5,-5},{-5,5,-5},{-5,5,5},{-5,-5,5}},
	 {{5,-5,-5},{5,5,-5},{5,5,5},{5,-5,5}},
	 {{5,-5,5},{5,-5,-5},{-5,-5,-5},{-5,-5,5}},
	 {{5,5,5},{5,5,-5},{-5,5,-5},{-5,5,5}}
};

  const int H[MAXPOLYS][POLYPOINTS][POLYCORDS] =
            { {{-10,-10,0},{-7,-10,0},{-7,10,0},{-10,10,0}},
              {{10,-10,0},{7,-10,0},{7,10,0},{10,10,0}},
              {{-9,-1,0},{9,-1,0},{9,2,0},{-9,2,0}},
              {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
              {{0,0,0},{0,0,0},{0,0,0},{0,0,0}} };

//  const int X[MAXPOLYS][POLYPOINTS][POLYCORDS] =
  int X[maxpolys][POLYPOINTS][POLYCORDS] =               //andadd
//	    { {{-7,-10,5},{10,7,5},{7,10,5},{-10,-7,5}},
//	      {{7,-10,-5},{-10,7,-5},{-7,10,-5},{10,-7,-5}},
//	      {{7,-10,5},{-10,7,5},{-7,10,5},{10,-7,5}},
//	      {{-7,-10,5},{10,7,5},{7,10,5},{-10,-7,5}},
//	      {{7,-10,-5},{-10,7,-5},{-7,10,-5},{10,-7,-5}},
//	      {{7,-10,5},{-10,7,5},{-7,10,5},{10,-7,5}} };

	    { {{-7,-10,-5},{10,7,-5},{7,10,-5},{-10,-7,-5}},
	      {{7,-10,-5},{-10,7,-5},{-7,10,-5},{10,-7,-5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{-7,-10,5},{10,7,5},{7,10,5},{-10,-7,5}},
	      {{7,-10,5},{-10,7,5},{-7,10,5},{10,-7,5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}} };



  const int I[MAXPOLYS][POLYPOINTS][POLYCORDS] =
            { {{-10,-10,0},{10,-10,0},{10,-7,0},{-10,-7,0}},
              {{-10,10,0},{10,10,0},{10,7,0},{-10,7,0}},
              {{-2,-9,0},{2,-9,0},{2,9,0},{-2,9,0}},
              {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
              {{0,0,0},{0,0,0},{0,0,0},{0,0,0}} };

  const int Z[MAXPOLYS][POLYPOINTS][POLYCORDS] =   //andadd
     { {{ 0, 0, 0},{ 7, 0, 0},{ 5, 0, 0},{ 0, 0, 0}},   // 1
       {{ 0, 0, 0},{ 0, 7, 0},{ 0, 5, 0},{ 0, 0, 0}},
       {{ 0, 7, 0},{ 7, 0, 0},{ -7, 0, 0},{ 0, -7, 0}},
       {{ 0, 0, 0},{ -7, 0, 0},{ -5, 0, 0},{ 0, 0, 0}},
       {{ 0, 0, 0},{ 0, -7, 0},{ 0, -5, 0},{ 0, 0, 0}} }; // 5



struct IPoint
{
  int x;
  int y;
  int z;
};  
struct IPoint lines[maxpolys][4],translated[maxpolys][4];
int lookup[360][2];  // sin and cos table
int poly1[200][2];
int ytopclip,ybotclip;
int xoff,yoff,zoff;


//                     //
// FUNCTION PROTOTYPES //
//                     //

  void DrawPoly     (int x1, int y1, int x2, int y2,
                     int x3, int y3, int x4, int y4,
                     byte Col, word Where);
  void drawpoly1    (int x1,int y1,int x2,int y2,int x3,    //andadd
		     int y3,int x4,int y4,char color,int where);
  void SetUpPoints  ();
  void setuppoints1 ();                            //andadd
  void RotatePoints (int X, int Y, int Z);
  void DrawPoints   ();
  void rotatepoints1(int X, int Y, int Z);         //andadd
  void drawpoints1  ();
  void Whizz        (int sub, int &deg);
  void MoveAround   ();
  void movearoundm   ();                           //andadd
  void movearoundc   ();                           //andadd
  void movearoundd   ();                           //andadd
  void movearounde   ();                           //andadd
  void movearoundf   ();                           //andadd
  void movearoundx   ();                           //andadd
  void MoveB   ();
  int  round   (float x);
  void PutPixel1(int X, int Y, char Color, int Where);
  void Putpixel(word X, word Y, byte Col, word Where);
  void Line2(int x1, int y1, int x2, int y2,
	       unsigned char Color, int where);

//            //
// STRUCTURES //
//            //

  // The data for every point we rotate
  struct Point {
    float x;
    float y;
    float z;
  };

//                              //
// GLOBAL VARIABLE DECLARATIONS //
//                              //

  byte far *Virscr=NULL;           // Pointer to our virtual screen
  word Vaddr;                      // Segment of our virtual screen
  float Lookup[360][2];            // Our sin and cos lookup tables
  int Xoff, Yoff, Zoff;            // Used for movement of the object
  Point Lines[MAXPOLYS][4];        // The base object being rotated
  Point Translated[MAXPOLYS][4];   // The rotated object


///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                                MAIN FUNCTION                              //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void main() {

  SetUpVirtual(Virscr,Vaddr);
  // always check to see if enough memory was allocated
  if (Virscr == NULL) {
    SetText();
    cout << "Insufficient memory for virtual screens, exiting...";
    exit(1);
  }

  clrscr();

  SetMCGA();
  SetUpPoints();
  setuppoints1();
  MoveAround();

  ShutDown(Virscr);
  SetText();

}


/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// DrawPoly() - This draws a polygon with 4 points at x1,y1, x2,y2, x3,y3, //
//              x4,y4 in color Col at location Where                       //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void DrawPoly(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4,
              byte Col, word Where) {

  int x, mny, mxy, mnx, mxx, yc;
  int mul1, div1, mul2, div2, mul3, div3, mul4, div4;

  // find the maximum y (mny) and minimum y (mny)
              mny = y1;
              mxy = y1;
  if (y2<mny) mny = y2;
  if (y2>mxy) mxy = y2;
  if (y3<mny) mny = y3;
  if (y3>mxy) mxy = y3;
  if (y4<mny) mny = y4;
  if (y4>mxy) mxy = y4;

  // if the mimimum or maximum is out of bounds, bring it back in
  if (mny<  0) mny =   0;
  if (mxy>199) mxy = 199;

  // verticle range checking
  if (mny>199) return;
  if (mxy< 0) return;

  // constants needed for intersection calculations
  mul1 = x1-x4;  div1 = y1-y4;
  mul2 = x2-x1;  div2 = y2-y1;
  mul3 = x3-x2;  div3 = y3-y2;
  mul4 = x4-x3;  div4 = y4-y3;

  for (yc=mny; yc<mxy; yc++) {
    mnx = 320;
    mxx =  -1;

    if ((y4 >= yc) || (y1 >= yc))
      if ((y4 <= yc) || (y1 <= yc))
        if (y4 != y1) {
          x = ((yc-y4) * mul1 / div1) + x4;
          if (x<mnx) mnx = x;
          if (x>mxx) mxx = x;
        }

    if ((y1 >= yc) || (y2 >= yc))
      if ((y1 <= yc) || (y2 <= yc))
        if (y1 != y2) {
          x = ((yc-y1) * mul2 / div2) + x1;
          if (x<mnx) mnx = x;
          if (x>mxx) mxx = x;
        }

    if ((y2 >= yc) || (y3 >= yc))
      if ((y2 <= yc) || (y3 <= yc))
        if (y2 != y3) {
          x = ((yc-y2) * mul3 / div3) + x2;
          if (x<mnx) mnx = x;
          if (x>mxx) mxx = x;
        }

    if ((y3 >= yc) || (y4 >= yc))
      if ((y3 <= yc) || (y4 <= yc))
        if (y3 != y4) {
          x = ((yc-y3) * mul4 / div4) + x3;
          if (x<mnx) mnx = x;
          if (x>mxx) mxx = x;
        }

    // horizontal range checking
    if (mnx<  0)  mnx =   0;
    if (mxx>319)  mxx = 319;

    if (mnx<=mxx)
      // draw the horizontal line
      Hline(mnx,mxx,yc,Col,Where);

  }
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// SetUpPoints() - This creates the lookup table.                          //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void SetUpPoints() {

  int loop1;

  // generate the sin() and cos() tables
  for (loop1=0; loop1<360; loop1++) {
    Lookup [loop1][0] = sin(rad(loop1));
    Lookup [loop1][1] = cos(rad(loop1));
  }
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// RotatePoints() - This rotates object lines by X,Y and Z, then places    //
//                  the result in Translated[]                             //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void RotatePoints(int X, int Y, int Z) {

  int loop1, loop2;
  Point temp;

  for (loop1=0; loop1<MAXPOLYS; loop1++) {
    for (loop2=0; loop2<4; loop2++) {
      temp.x = Lines[loop1][loop2].x;
      temp.y = Lookup[X][1] * Lines[loop1][loop2].y - Lookup[X][0] * Lines[loop1][loop2].z;
      temp.z = Lookup[X][0] * Lines[loop1][loop2].y + Lookup[X][1] * Lines[loop1][loop2].z;
      Translated[loop1][loop2] = temp;

      if (Y>0) {
        temp.x = Lookup[Y][1] * Translated[loop1][loop2].x - Lookup[Y][0] * Translated[loop1][loop2].y;
        temp.y = Lookup[Y][0] * Translated[loop1][loop2].x + Lookup[Y][1] * Translated[loop1][loop2].y;
        temp.z = Translated[loop1][loop2].z;
        Translated[loop1][loop2] = temp;
      }

      if (Z>0) {
        temp.x = Lookup[Z][1] * Translated[loop1][loop2].x + Lookup[Z][0] * Translated[loop1][loop2].z;
        temp.y = Translated[loop1][loop2].y;
        temp.z = Lookup[Z][0] * Translated[loop1][loop2].x + Lookup[Z][1] * Translated[loop1][loop2].z;
        Translated[loop1][loop2] = temp;
      }
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// DrawPoints() - This draws the translated object to the virtual screen.  //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void DrawPoints() {

  int nx, ny, nx2, ny2, nx3, ny3, nx4, ny4, temp, loop1;

  for (loop1=0; loop1<MAXPOLYS; loop1++) {
    if ((Translated[loop1][0].z+Zoff<0) && (Translated[loop1][1].z+Zoff<0) &&
        (Translated[loop1][2].z+Zoff<0) && (Translated[loop1][4].z+Zoff<0)) {

      temp = Translated[loop1][0].z + Zoff;
      nx   = ((256*Translated[loop1][0].x) / temp) + Xoff;
      ny   = ((256*Translated[loop1][0].y) / temp) + Yoff;

      temp = Translated[loop1][1].z + Zoff;
      nx2  = ((256*Translated[loop1][1].x) / temp) + Xoff;
      ny2  = ((256*Translated[loop1][1].y) / temp) + Yoff;

      temp = Translated[loop1][2].z + Zoff;
      nx3  = ((256*Translated[loop1][2].x) / temp) + Xoff;
      ny3  = ((256*Translated[loop1][2].y) / temp) + Yoff;

      temp = Translated[loop1][3].z + Zoff;
      nx4  = ((256*Translated[loop1][3].x) / temp) + Xoff;
      ny4  = ((256*Translated[loop1][3].y) / temp) + Yoff;

//      DrawPoly(nx,ny,nx2,ny2,nx3,ny3,nx4,ny4,13,Vaddr);
      DrawPoly(nx,ny,nx2,ny2,nx3,ny3,nx4,ny4,9,Vaddr);
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Whizz() - This function moves the letters from one side of the screen   //
//           to the other and also zooms them closer as they move.         //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Whizz(int sub, int &deg) {

  int loop1;

  for (loop1=(-64); loop1<(-4); loop1++) {

    Zoff = (loop1 * 8) - 15;
    if (sub == 1) Xoff -= 7; else Xoff += 7;
    RotatePoints(deg,deg,deg);
    DrawPoints();
    Flip(Vaddr,VGA);
    Cls(0,Vaddr);
    deg = (deg + 5) % 360;
  }
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAround() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround() {

  int ch;

// cout << "\rType one: A S P H Y X I A";
 cout << "\rType one: B C D E F M X";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
	case 'x': movearoundx(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

  void MoveB() {
  int deg=0, loop1, loop2;

  Yoff = 100;
  Xoff = 350;
  Cls(0,Vaddr);

    for (loop1=0; loop1<MAXPOLYS; loop1++)
    for (loop2=0; loop2<POLYPOINTS; loop2++) {
      Lines[loop1][loop2].x = B[loop1][loop2][0];
      Lines[loop1][loop2].y = B[loop1][loop2][1];
      Lines[loop1][loop2].z = B[loop1][loop2][2];
    }
  Whizz(1,deg);

  Cls(0,Vaddr);
  Cls(0,VGA);

  Xoff = 160;

    DrawPoints();
    Flip(Vaddr,VGA);
    Cls(0,Vaddr);
    RotatePoints(deg,deg,deg);
    deg = (deg + 5) % 360;
// cout << "\rType one: A S P H Y X I A ";
 cout << "\rType one: B C D E F M X, that was: B";

  }


// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Hline (x1,x2,y:word;col:byte;where:word); assembler;
//  { This draws a horizontal line from x1 to x2 on line y in color col }
// Version of Hline to add to the current screen color, for "glenzing"
void Hline2(int x1, int x2, int y, char col, int where)
{
 asm mov   ax,where
 asm mov   es,ax
 asm mov   ax,y
 asm mov   di,ax
 asm shl   ax,8
 asm shl   di,6
 asm add   di,ax
 asm add   di,x1
 asm mov   cx,x2
 asm sub   cx,x1
 asm cmp   cx,0
 asm jle   End
 Loop1:
 asm mov   al,es:[di] // ;  Read current color
 asm add   al,col     // ;  Add to new color
 asm stosb            // ;  Write new pixel
 asm loop  Loop1
 End:
}

///////////////////////////////////////////////////////////////////////////
//Procedure doside (x1,y1,x2,y2:integer);
//  { This scans the side of a polygon and updates the poly variable }
void doside(int x1,int y1,int x2,int y2)
{
  int temp,x,xinc,loop1;
  
  if(y1==y2)return;
  if(y2<y1)
  {
    temp=y2;
    y2=y1;
    y1=temp;
    temp=x2;
    x2=x1;
    x1=temp;
  }
  xinc=((x2-x1)<<7)/(y2-y1);
  x=(x1<<7);
  for(loop1=y1;loop1<=y2;loop1++)
  {
    if((loop1>ytopclip-1)&&(loop1<ybotclip+1))
    {
      if((x>>7)<poly1[loop1][0]) poly1[loop1][0]=(x>>7); // min
      if((x>>7)>poly1[loop1][1]) poly1[loop1][1]=(x>>7); // max
    }
    x+=xinc;
  }
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure drawpoly1(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte;where:word);
// This draw a polygon with 4 points at x1,y1 , x2,y2 , x3,y3 , x4,y4
// in color col }
void drawpoly1(int x1,int y1,int x2,int y2,int x3,
     int y3,int x4,int y4,char color,int where)
{
  int miny,maxy,loop1;

asm    mov   si,offset poly1
asm    mov   cx,200
Loop1:
asm    mov   ax,32766
asm    mov   ds:[si],ax
asm    inc   si
asm    inc   si
asm    mov   ax,-32767
asm    mov   ds:[si],ax
asm    inc   si
asm    inc   si
asm    loop  Loop1
// { Setting the minx and maxx values to extremes }
  miny=y1;
  maxy=y1;
  if (y2<miny)  miny=y2;
  if (y3<miny)  miny=y3;
  if (y4<miny)  miny=y4;
  if (y2>maxy)  maxy=y2;
  if (y3>maxy)  maxy=y3;
  if (y4>maxy)  maxy=y4;
  if (miny<ytopclip)  miny=ytopclip;
  if (maxy>ybotclip)  maxy=ybotclip;
  if ((miny>199) || (maxy<0)) return;

  doside (x1,y1,x2,y2);
  doside (x2,y2,x3,y3);
  doside (x3,y3,x4,y4);
  doside (x4,y4,x1,y1);

  for( loop1= miny;loop1<=maxy;loop1++)
    Hline2 (poly1[loop1][0],poly1[loop1][1],loop1,color,where);
    // Hline (poly[loop1][0],poly[loop1][1],loop1,color,where);
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure setuppoints1;
//  { This creates the lookup table }
void setuppoints1()
{
  int loop1;
  for(loop1=0;loop1<360;loop1++)
  {
    lookup[loop1][0]=round((float)sin((double)rad(loop1))*(float)16384);
    lookup[loop1][1]=round((float)cos((double)rad(loop1))*(float)16384);
  }
}

int round(float x)
{
  if(x>=0)
    return (int)(x+0.5);
  else
    return (int)(x-0.5);
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure rotatepoints1 (x,Y,z:Integer);
//  { This rotates the object in lines to translated }
void rotatepoints1(int x, int y, int z)
{
  int loop1,loop2;
  int a,b,c;
  
  for(loop1=0;loop1<maxpolys;loop1++)
  {
    for(loop2=0;loop2<4;loop2++)
    {
      b=lookup[y][1];
      c=lines[loop1][loop2].x;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        mov   a,dx
      }
      b=lookup[y][0];
      c=lines[loop1][loop2].z;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        add   a,dx
      }
      translated[loop1][loop2].x=a;
      translated[loop1][loop2].y=lines[loop1][loop2].y;
      b=-lookup[y][0];
      c=lines[loop1][loop2].x;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        mov   a,dx
      }
      b=lookup[y][1];
      c=lines[loop1][loop2].z;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        add   a,dx
      }
      translated[loop1][loop2].z=a;


      if(x!=0)
      {
        b=lookup[x][1];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[x][0];
        c=translated[loop1][loop2].z;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          sub   a,dx
        }
        b=lookup[x][0];
        c=translated[loop1][loop2].y;
        translated[loop1][loop2].y=a;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[x][1];
        c=translated[loop1][loop2].z;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          add   a,dx
        }
        translated[loop1][loop2].z=a;
      }

      if(z!=0)
      {
        b=lookup[z][1];
        c=translated[loop1][loop2].x;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[z][0];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          sub   a,dx
        }
        b=lookup[z][0];
        c=translated[loop1][loop2].x;
        translated[loop1][loop2].x=a;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[z][1];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
	  sal   ax,1
          rcl   dx,1
          add   a,dx
        }
        translated[loop1][loop2].y=a;
      }
    }
  }
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//  Procedure drawpoints1;
//  { This draws the translated object to the virtual screen }
void drawpoints1()
{
  int loop1;
  int temp;
  int nx;
  int tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4;
  
  for(loop1=0;loop1<maxpolys;loop1++)
  {
    if((translated[loop1][0].z+zoff<0)&&(translated[loop1][1].z+zoff<0)
     &&(translated[loop1][2].z+zoff<0)&&(translated[loop1][3].z+zoff<0))
     {
      temp=round (translated[loop1][0].z)+zoff;
      nx=translated[loop1][0].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx1=nx;
      nx=translated[loop1][0].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty1=nx;

      temp=round (translated[loop1][1].z)+zoff;
      nx=translated[loop1][1].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx2=nx;
      nx=translated[loop1][1].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty2=nx;

      temp=round (translated[loop1][2].z)+zoff;
      nx=translated[loop1][2].x;
      asm  {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx3=nx;
      nx=translated[loop1][2].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty3=nx;

      temp=round (translated[loop1][3].z)+zoff;
      nx=translated[loop1][3].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx4=nx;
      nx=translated[loop1][3].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty4=nx;

      drawpoly1 (tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4,(char)(loop1),Vaddr);
    }
  }
}

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure Pal(ColorNo : Byte; R,G,B : Byte);
void Pal(char ColorNo, char R, char G, char B)
//  This sets the Red, Green and Blue values of a certain color 
{
   outportb(0x3c8,ColorNo);
   outportb(0x3c9,R);
   outportb(0x3c9,G);
   outportb(0x3c9,B);
}
//////////////////////////////////////////////////////////////////

    void Line2(int x1, int y1, int x2, int y2,
	       unsigned char Color, int Where)

//////////////////////////////////////////////////////////////////
{
  int dx,dy,incr1,incr2,d,x,y,xend,yend,yinc,xinc;

  dx=abs(x2-x1);
  dy=abs(y2-y1);

  if(dx>=dy) // slope < 1
  {
    if(x1>x2)
	{
	  x=x2; y=y2; xend=x1;
	  if(dy==0) yinc=0;
	  else { if(y2>y1) yinc=-1; else yinc=1;}
	}
	else
	{
	  x=x1; y=y1; xend=x2;
	  if(dy==0) yinc=0;
	  else { if(y2>y1) yinc=1; else yinc=-1;}
	}
    incr1=2*dy; d=incr1-dx; incr2=2*(dy-dx);
	PutPixel1(x,y,Color,Where);
    while(x<xend)
    {
      x++;
      if(d<0) d+=incr1;
      else { y+=yinc; d+=incr2;}
	  PutPixel1(x,y,Color,Where);
    }
  }
  else
  {
    if(y1>y2)
	{ 
	  x=x2; y=y2; yend=y1;
	  if(dx==0) xinc=0;
	  else { if(x2>x1) xinc = -1; else xinc = 1;}
    }
	else
	{
	  x=x1; y=y1; yend=y2;
	  if(dx==0) xinc=0;
	  else { if(x2>x1) xinc=1; else xinc = -1;}
	}
	incr1=2*dx; d=incr1-dy; incr2=2*(dx-dy);
	PutPixel1(x,y,Color,Where);
	while(y<yend)
	{
	  y++;
	  if(d<0) d+=incr1;
	  else { x+=xinc; d+=incr2; }
	  PutPixel1(x,y,Color,Where);
	}
  }
}

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure PutPixel1 (X,Y : Integer; Col : Byte);
//  This puts a pixel on the screen by writing directly to memory. 

void PutPixel1(int X, int Y, char Color, int Where)
{
  unsigned char far* VGAScreenPtr;
  unsigned int offset;
//    VGAScreenPtr=MK_FP(Where,(unsigned)(X+(Y*320)));
  offset=(unsigned)X + (unsigned)(Y<<8) + (unsigned)(Y<<6);

//screen = (unsigned int *) MK_FP(0xB000, 0); //from help

//  VGAScreenPtr=MK_FP(Where,offset);
    VGAScreenPtr=(unsigned char *)MK_FP(Where,offset); //andadd
   *VGAScreenPtr=Color;
}     
//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//procedure WaitRetrace; assembler;
/*
    This waits until you are in a Verticle Retrace ... this means that all
    screen manipulation you do only appears on screen in the next verticle
    retrace ... this removes most of the "fuzz" that you see on the screen
    when changing the pallette. It unfortunately slows down your program
    by "synching" your program with your monitor card ... it does mean
    that the program will run at almost the same speed on different
    speeds of computers which have similar monitors. In our SilkyDemo,
    we used a WaitRetrace, and it therefore runs at the same (fairly
    fast) speed when Turbo is on or off. 
*/

void WaitRetrace()
{
  asm  mov dx,3DAh
l1:
 asm   in al,dx
 asm   and al,08h
 asm   jnz l1
l2:
 asm   in al,dx
 asm   and al,08h
 asm   jz  l2
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// procedure flip(source,dest:Word);
//   { This copies the entire screen at "source" to destination }
void Flip2(int Source, int Dest)
{
  asm {
    push    ds
    mov     ax, Dest
    mov     es, ax
    mov     ax, Source
    mov     ds, ax
    xor     si, si
    xor     di, di
    mov     cx, 32000
    rep     movsw
    pop     ds
  }
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearoundm;
//{ This is the main display procedure for cube. }
void movearoundm()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=a[loop1][loop2][0]*8;
      lines[loop1][loop2].y=a[loop1][loop2][1]*8;
      lines[loop1][loop2].z=a[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
//  Line2(0,100,319,100,100,VGA);
  Line2(0,100,319,100,0,VGA);
//  delay (500);
//  delay (100);

//  for(loop1=0;loop1<100/clipincr;loop1++)
  for(loop1=0;loop1<80/clipincr;loop1++)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
//    Line2(0,ytopclip,319,ytopclip,100,Vaddr);
//    Line2(0,ybotclip,319,ybotclip,100,Vaddr);
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
//    Line2(0,0,319,0,100,Vaddr);
//    Line2(0,199,319,199,100,Vaddr);
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    deg+=degincr; if(deg==360)deg=0;
    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: B C D E F M X, that was: M";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit

}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearoundc;
//{ This is the main display procedure for cube. }
void movearoundc()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);
//    Pal(100,63,63,63);

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=c[loop1][loop2][0]*8;
      lines[loop1][loop2].y=c[loop1][loop2][1]*8;
      lines[loop1][loop2].z=c[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

//  ytopclip=101;
//  ybotclip=100;
  ytopclip=101;
  ybotclip=100;
//  Line2(0,100,319,100,100,VGA);   //intro line
//  Line2(0,100,319,100,0,VGA);
  Line2(0,100,319,100,0,VGA);
  delay (500);
//  for(loop1=0;loop1<100/clipincr;loop1++)
  for(loop1=0;loop1<75/clipincr;loop1++)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
//    Line2(0,ytopclip,319,ytopclip,100,Vaddr);
//    Line2(0,ybotclip,319,ybotclip,100,Vaddr);
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
//    Line2(0,0,319,0,100,Vaddr);
//    Line2(0,199,319,199,100,Vaddr);
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    deg+=degincr; if(deg==360)deg=0;
    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

//  for(loop1=0;loop1<100/clipincr;loop1++)
  for(loop1=0;loop1<75/clipincr;loop1++)
  {
    ytopclip=ytopclip+clipincr;
    ybotclip=ybotclip-clipincr;
    rotatepoints1(deg,deg,deg);
    drawpoints1();
//    Line2(0,ytopclip,319,ytopclip,100,Vaddr);
//    Line2(0,ybotclip,319,ybotclip,100,Vaddr);
    Line2(0,ytopclip,319,ytopclip,8,Vaddr);
    Line2(0,ybotclip,319,ybotclip,8,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    deg+=degincr; if(deg==360)deg=0;
  }
 cout << "\rType one: B C D E F M X, that was: C";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
	case 'x': movearoundx(); break;

    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit

}
// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearoundd;
//{ This is the main display procedure for cube. }
void movearoundd()
{
  int deg=0, loop1, loop2;
  int degincr=2;  // degincr must divide 360!    //andadd

  Yoff = 100;
  Xoff = 350;
  Zoff = -500;

  Cls(0,Vaddr);

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);

//  deg=0;
  Cls (0,Vaddr);

  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      Lines[loop1][loop2].x=d[loop1][loop2][0]*8;
      Lines[loop1][loop2].y=d[loop1][loop2][1]*8;
      Lines[loop1][loop2].z=d[loop1][loop2][2]*8;

    }

  Whizz(1,deg);

  Cls(0,Vaddr);
  Cls(0,VGA);

  Xoff = 160;

//    drawpoints1();
//    Flip2(Vaddr,VGA);
//    Cls(0,Vaddr);
//    rotatepoints1(deg,deg,deg);
//    deg = (deg + 5) % 360;

    rotatepoints1(deg,deg,deg);
    drawpoints1();
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!



 cout << "\rType one: B C D E F M, that was: D";

  }


// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearounde;
//{ This is the main display procedure for cube. }

void movearounde()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=E[loop1][loop2][0]*8;
      lines[loop1][loop2].y=E[loop1][loop2][1]*8;
      lines[loop1][loop2].z=E[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);
//  delay (300);
  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: B C D E F M X, that was: E";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
	case 'x': movearoundx(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearoundf;
//{ This is the main display procedure for cube. }

void movearoundf()
{
  int deg,loop1,loop2;
//  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=F[loop1][loop2][0]*8;
      lines[loop1][loop2].y=F[loop1][loop2][1]*8;
      lines[loop1][loop2].z=F[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);
//  delay (300);

//  for(loop1=0;loop1<100/clipincr;loop1++)
  for(loop1=0;loop1<50/clipincr;loop1++)
  {
    rotatepoints1(deg,deg,deg);

// Xoff = 160;       //andadd


    drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    rotatepoints1(deg,deg,deg);   //andadd

    deg = (deg + 5) % 360;   //andadd


//    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }

  while(1)
  {
//    rotatepoints1(deg,deg,deg);

// Xoff = 160;       //andadd


    drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    rotatepoints1(deg,deg,deg);         //andadd

//    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    deg = (deg + 5) % 360;       //andadd


    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: B C D E F M X, that was: F";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
	case 'x': movearoundx(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit

}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure movearoundx;
//{ This is the main display procedure for cube. }

void movearoundx()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

//  for(loop1=1;loop1<16;loop1++)
//    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));
//  Pal(100,50,50,50);

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=X[loop1][loop2][0]*8;
      lines[loop1][loop2].y=X[loop1][loop2][1]*8;
      lines[loop1][loop2].z=X[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);
//  delay (300);
  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    rotatepoints1(deg,deg,deg);
    drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: B C D E F M X, that was: X";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'b': MoveB(); break;
	case 'c': movearoundc(); break;
	case 'd': movearoundd(); break;
	case 'e': movearounde(); break;
	case 'f': movearoundf(); break;
	case 'm': movearoundm(); break;
	case 'x': movearoundx(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit

}



/*
   Welcome to the fourteenth trainer! This one is on glenzing, and also
   throws in a faster poly, fixed point math and a lot more assembler.
   This isn't very interactive ... hit any key to start, and then
   hit the [ESC] key to exit. It is a glenzed cube spinning in the
   middle of the screen. Read the text file for more information on
   how the fixed point etc. works ... it will also help a lot if you
   compare it with TUTPROG9.PAS, as this is the same 3D system, just
   speeded up.');
*/






